from zope import interface
from zope import component

import interfaces

class USDCurrency(object):
    interface.implements(interfaces.IUSD)

    def __init__(self, value):
        self.value = value

    def get_value(self):
        return self.value

class RealConverter(object):
    component.adapts(interfaces.IUSD)
    
    interface.implements(interfaces.IConverter,
                         interfaces.ICurrency)
    
    def __init__(self, usd):
        self.usd = usd

    # implementation for IConverter
    def convert(self):
        return self.usd.get_value() * 2.247

    # implementation for ICurrency
    def currency_name(self):
        return "Brazilian Real"

    def currency_symbol(self):
        return "R$"

component.provideSubscriptionAdapter(RealConverter,
                                     provides=interfaces.ICurrency)
component.provideAdapter(RealConverter,
                         provides=interfaces.IConverter, name='R$')


class PesoConverter(object):
    component.adapts(interfaces.IUSD)
    
    interface.implements(interfaces.IConverter,
                         interfaces.ICurrency)
    
    def __init__(self, usd):
        self.usd = usd

    # implementation for IConverter
    def convert(self):
        return self.usd.get_value() * 3

    # implementation for ICurrency
    def currency_name(self):
        return "Argentine Peso"

    def currency_symbol(self):
        return "ARS"

component.provideSubscriptionAdapter(PesoConverter,
                                     provides=interfaces.ICurrency)
component.provideAdapter(PesoConverter,
                         provides=interfaces.IConverter, name='ARS')
