import zope.interface


class IUSD(zope.interface.Interface):
    """Currency value in US$."""

    def get_value():
        """Return the stored value, or None if no value provided."""

class ICurrency(zope.interface.Interface):
    """Currency information."""
        
    def currency_name():
        """Return the name of the target currency."""

    def currency_symbol():
        """Return the symbol for the target currency, i.e. US$."""
    
class IConverter(zope.interface.Interface):
    """Adapter interface for converting IUSD to a target currency."""
    
    def convert():
        """Convert US$ value to the target currency."""
