from zope import interface
from zope import component

import interfaces

class PesoConverter(object):
    component.adapts(interfaces.IUSD)
    
    interface.implements(interfaces.IConverter,
                         interfaces.ICurrency)
    
    def __init__(self, usd):
        self.usd = usd

    # implementation for IConverter
    def convert(self):
        return self.usd.get_value() * 3

    # implementation for ICurrency
    def currency_name(self):
        return "Argentine Peso"

    def currency_symbol(self):
        return "ARS"

def register():
    component.provideSubscriptionAdapter(PesoConverter,
                                         provides=interfaces.ICurrency)
    component.provideAdapter(PesoConverter,
                             provides=interfaces.IConverter, name='ARS')
