from zope import interface
from zope import component

import interfaces

class RealConverter(object):
    component.adapts(interfaces.IUSD)
    
    interface.implements(interfaces.IConverter,
                         interfaces.ICurrency)
    
    def __init__(self, usd):
        self.usd = usd

    # implementation for IConverter
    def convert(self):
        return self.usd.get_value() * 2.247

    # implementation for ICurrency
    def currency_name(self):
        return "Brazilian Real"

    def currency_symbol(self):
        return "R$"

def register():
    component.provideSubscriptionAdapter(RealConverter,
                                         provides=interfaces.ICurrency)
    component.provideAdapter(RealConverter,
                             provides=interfaces.IConverter, name='R$')

