from zope import interface
from zope import component

import interfaces

class RealConverter:
    interface.implements(interfaces.IConverter)

    def currency_name(self):
        """Return the name of the target currency."""

        return "Real"
    
    def currency_symbol(self):
        """Return the symbol for the target currency, i.e. US$."""

        return "R$"
    
    def convert(self,usd_value):
        """Convert US$ value to the target currency."""

        return usd_value * 2.247

# register the converter as a utility
converter = RealConverter()
component.provideUtility(converter)

