from Tkinter import *
import sys
from zope import component

import interfaces
import components

class CurrencyConverterApp:

    def __init__(self, root):

        # lookup our converter
        converter = component.getUtility(interfaces.IConverter)
        
        frame = Frame(root)
        frame.pack()

        # input widgets
        lblInput = Label(frame, text="Value (US$): ").grid(row=0)
        self.txtInput = Entry(frame)
        self.txtInput.grid(row=0, column=1)

        # output widgets
        lblOutput = Label(frame,
                          text=converter.currency_name()).grid(row=1)
        self.txtOutput = Entry(frame)
        self.txtOutput.grid(row=1, column=1)
        
        # command buttons
        Button(frame, text="Convert", command=self.convert).grid(row=2)
        Button(frame, text="Exit",    command=self.quit).grid(row=2, column=1)

    def convert(self):

        # lookup our converter
        converter = component.getUtility(interfaces.IConverter)
        
        # clear the output widget
        self.txtOutput.delete(0,END)

        # set the output widget to input * 2
        self.txtOutput.insert(0, converter.convert(float(self.txtInput.get())))

    def quit(self):

        sys.exit()
    
if __name__ == '__main__':
    root = Tk()
    app = CurrencyConverterApp(root)

    root.mainloop()
    

    
